require 'morpheus/api/api_client'

class Morpheus::LibraryClusterLayoutsInterface < Morpheus::APIClient

  def list(params={})
    url = "#{@base_url}/api/library/cluster-layouts"
    headers = { params: params, authorization: "Bearer #{@access_token}" }
    opts = {method: :get, url: url, headers: headers}
    execute(opts)
  end

  def get(id, params={})
    raise "#{self.class}.get() passed a blank id!" if id.to_s == ''
    url = "#{@base_url}/api/library/cluster-layouts/#{id}"
    headers = { params: params, authorization: "Bearer #{@access_token}" }
    opts = {method: :get, url: url, headers: headers}
    execute(opts)
  end

  def create(payload)
    url = "#{@base_url}/api/library/cluster-layouts"
    headers = { :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json' }
    opts = {method: :post, url: url, headers: headers, payload: payload.to_json}
    execute(opts)
  end

  def update(id, payload)
    url = "#{@base_url}/api/library/cluster-layouts/#{id}"
    headers = { :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json' }
    opts = {method: :put, url: url, headers: headers, payload: payload.to_json}
    execute(opts)
  end

  def clone(id, params)
    url = "#{@base_url}/api/library/cluster-layouts/#{id}/clone"
    headers = { :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json', params: params }
    opts = {method: :post, url: url, headers: headers}
    execute(opts)
  end

  def destroy(id, payload={})
    url = "#{@base_url}/api/library/cluster-layouts/#{id}"
    headers = { :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json' }
    opts = {method: :delete, url: url, headers: headers, payload: payload.to_json}
    execute(opts)
  end
end
