require 'morpheus/api/api_client'

class Morpheus::NetworkPoolIpsInterface < Morpheus::APIClient

  def get(pool_id, id, params={})
    raise "#{self.class}.get() passed a blank id!" if id.to_s == ''
    url = "#{@base_url}/api/networks/pools/#{pool_id}/ips/#{id}"
    headers = { params: params, authorization: "Bearer #{@access_token}" }
    opts = {method: :get, url: url, headers: headers}
    execute(opts)
  end

  def list(pool_id, params={})
    url = "#{@base_url}/api/networks/pools/#{pool_id}/ips"
    headers = { params: params, authorization: "Bearer #{@access_token}" }
    opts = {method: :get, url: url, headers: headers}
    execute(opts)
  end

  def create(pool_id, payload)
    url = "#{@base_url}/api/networks/pools/#{pool_id}/ips"
    headers = { :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json' }
    opts = {method: :post, url: url, headers: headers, payload: payload.to_json}
    execute(opts)
  end

  def update(pool_id, id, payload)
    url = "#{@base_url}/api/networks/pools/#{pool_id}/ips/#{id}"
    headers = { :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json' }
    opts = {method: :put, url: url, headers: headers, payload: payload.to_json}
    execute(opts)
  end

  def destroy(pool_id, id, params={})
    url = "#{@base_url}/api/networks/pools/#{pool_id}/ips/#{id}"
    headers = { :params => params, :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json' }
    opts = {method: :delete, url: url, headers: headers}
    execute(opts)
  end

end
