require 'morpheus/api/api_client'

# This is deprecated, use SubnetsInterface instead.
class Morpheus::NetworkSubnetsInterface < Morpheus::APIClient

  def get(network_id, id, params={})
    raise "#{self.class}.get() passed a blank id!" if id.to_s == ''
    url = "#{@base_url}/api/networks/#{network_id}/subnets/#{id}"
    headers = { params: params, authorization: "Bearer #{@access_token}" }
    opts = {method: :get, url: url, headers: headers}
    execute(opts)
  end

  def list(network_id, params={})
    url = "#{@base_url}/api/networks/#{network_id}/subnets"
    headers = { params: params, authorization: "Bearer #{@access_token}" }
    opts = {method: :get, url: url, headers: headers}
    execute(opts)
  end

  def create(network_id, payload)
    url = "#{@base_url}/api/networks/#{network_id}/subnets"
    headers = { :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json' }
    opts = {method: :post, url: url, headers: headers, payload: payload.to_json}
    execute(opts)
  end

  def update(network_id, id, payload)
    url = "#{@base_url}/api/networks/#{network_id}/subnets/#{id}"
    headers = { :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json' }
    opts = {method: :put, url: url, headers: headers, payload: payload.to_json}
    execute(opts)
  end

  def destroy(network_id, id, params={})
    url = "#{@base_url}/api/networks/#{network_id}/subnets/#{id}"
    headers = { :params => params, :authorization => "Bearer #{@access_token}", 'Content-Type' => 'application/json' }
    opts = {method: :delete, url: url, headers: headers}
    execute(opts)
  end

end
